import Ajv from 'ajv';
import { ILayerConfig } from '../layer/ILayerService';
import { IGlobalConfigService, ISceneConfig } from './IConfigService';
export default class GlobalConfigService implements IGlobalConfigService {
    /**
     * 全部场景配置项缓存
     */
    private sceneConfigCache;
    /**
     * 场景配置项校验器
     */
    private sceneConfigValidator;
    /**
     * 地图配置项校验器
     */
    private mapConfigValidator;
    /**
     * 全部图层配置项缓存
     */
    private layerConfigCache;
    /**
     * 保存每一种 Layer 配置项的校验器
     */
    private layerConfigValidatorCache;
    getSceneConfig(sceneId: string): Partial<ISceneConfig>;
    getSceneWarninfo(id: string): any;
    setSceneConfig(sceneId: string, config: Partial<ISceneConfig>): void;
    validateSceneConfig(data: object): {
        valid: false;
        errors: Ajv.ErrorObject[] | null | undefined;
        errorText: string;
    } | {
        valid: boolean;
        errors: null;
        errorText: null;
    };
    validateMapConfig(data: object): {
        valid: false;
        errors: Ajv.ErrorObject[] | null | undefined;
        errorText: string;
    } | {
        valid: boolean;
        errors: null;
        errorText: null;
    };
    getLayerConfig<IChildLayerConfig>(layerId: string): Partial<ILayerConfig & ISceneConfig & IChildLayerConfig>;
    setLayerConfig(sceneId: string, layerId: string, config: Partial<ILayerConfig>): void;
    registerLayerConfigSchemaValidator(layerName: string, schema: object): void;
    validateLayerConfig(layerName: string, data: object): {
        valid: false;
        errors: Ajv.ErrorObject[] | null | undefined;
        errorText: string;
    } | {
        valid: boolean;
        errors: null;
        errorText: null;
    };
    clean(): void;
    private registerSceneConfigSchemaValidator;
    private validate;
}
