"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getAngle = getAngle;
exports.createVec3 = createVec3;

var _glMatrix = require("gl-matrix");

function getAngle(angle) {
  if (angle === undefined) {
    return 0;
  } else if (angle > 360 || angle < -360) {
    return angle % 360;
  }

  return angle;
}

function createVec3(x, y, z) {
  return x instanceof _glMatrix.vec3 ? _glMatrix.vec3.clone(x) : x instanceof _glMatrix.vec4 ? _glMatrix.vec3.fromValues(x[0], x[1], x[2]) : _glMatrix.vec3.fromValues(x, y, z);
}
//# sourceMappingURL=math.js.map